<?php
declare(strict_types=1);

namespace App\State\Provider\Core;

use ApiPlatform\Metadata\GetCollection;
use ApiPlatform\Metadata\Operation;
use ApiPlatform\State\ProviderInterface;
use App\ApiResources\Core\File\DownloadRequest;
use App\Enum\Core\FileStatusEnum;
use App\Repository\Core\FileRepository;
use App\Service\File\Exception\FileNotFoundException;
use App\Service\File\FileManager;
use RuntimeException;
use Symfony\Component\HttpFoundation\HeaderUtils;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;

/**
 * Custom provider pour le téléchargement des fichiers du LocalStorage
 */
final class DownloadRequestProvider implements ProviderInterface
{
    public function __construct(
        private readonly FileRepository $fileRepository,
        private readonly FileManager    $fileManager,
    ) {}

    /**
     * @param Operation $operation
     * @param array<mixed> $uriVariables
     * @param array<mixed> $context
     * @return Response|RedirectResponse
     * @throws FileNotFoundException
     */
    public function provide(Operation $operation, array $uriVariables = [], array $context = []): Response | RedirectResponse
    {
        if($operation instanceof GetCollection) {
            throw new RuntimeException('not supported', 500);
        }

        return $this->serveFile($uriVariables['fileId']);
    }

    /**
     * @param int $fileId
     * @return Response
     * @throws FileNotFoundException
     */
    protected function serveFile(int $fileId): Response {
        $file = $this->fileRepository->find($fileId);

        if (empty($file)) {
            throw new RuntimeException("File " . $fileId . " does not exist; abort.");
        }
        if ($file->getStatus() !== FileStatusEnum::READY()->getValue()) {
            throw new RuntimeException("File " . $fileId . " has " . $file->getStatus() . " status; abort.");
        }

        $content = $this->fileManager->read($file);

        // Build the response and attach the file to it
        // @see https://symfony.com/doc/current/components/http_foundation.html#serving-files
        $response = new Response($content);

        $response->headers->set('Charset', 'UTF-8');
        $response->headers->set('Access-Control-Expose-Headers', 'Content-Disposition');

        if (!empty($file->getMimeType())) {
            $response->headers->set('Content-Type', $file->getMimeType());
        }

        $response->headers->set(
            'Content-Disposition',
            HeaderUtils::makeDisposition(HeaderUtils::DISPOSITION_ATTACHMENT, $file->getName())
        );

        return $response;
    }

}
